Public Class CMeasurement
    Friend instrSession As Integer
    Friend run As Boolean
    Friend view As Dialog
    Private rsesci_status As Integer
    Private traceStatus, noofPoints, points, scan1points, scan2points As Int32

    Sub RunMeasurement()
        Dim result As Double
        Dim line As Integer
        Dim tempT1(100000) As Double
        Dim tempT2(100000) As Double
        Dim scan1tempT1(100000) As Double
        Dim scan1tempT2(100000) As Double
        Dim scan2tempT1(100000) As Double
        Dim scan2tempT2(100000) As Double
        Dim tempT3(100000) As Double
        Dim tempStatusData(100000) As Byte
        Dim xFirstIncrement, xSecondIncrement, xIncrement As Double
        Dim partTempT1 As Array
        Dim partTempT2 As Array
        Dim partTempT3 As Array

        On Error GoTo ErrorHandle

        points = 0
        view.measLabel.Visible = True
        view.sampleCount.Text = 0
        traceStatus = 0
        view.sampleCount.Visible = True
        Do
            ' ------ Data block transfer
            ' ------ All transferred blocks are collected and evaluated
            traceStatus = (traceStatus And 4096)
            If traceStatus = 0 Then ' last of all blocks (for multiple scans after the last scan)
                System.Threading.Thread.Sleep(250)
                rsesci_status = rsesci_ReadScanMeasurement(instrSession, 100000, traceStatus, noofPoints, tempStatusData(0), tempT1(points), tempT2(points), tempT3(points))

                If rsesci_status = 0 Then
                    If ((traceStatus And 1) = 1) Then
                        Array.Copy(tempT1, 0, scan1tempT1, scan1points, noofPoints)
                        Array.Copy(tempT2, 0, scan1tempT2, scan1points, noofPoints)
                        scan1points += noofPoints
                    Else
                        Array.Copy(tempT1, 0, scan2tempT1, scan2points, noofPoints)
                        Array.Copy(tempT2, 0, scan2tempT2, scan2points, noofPoints)
                        scan2points += noofPoints
                    End If
                    points += noofPoints
                    view.sampleCount.Text = points.ToString()
                End If
            Else
                    run = False
                    view.EnableButtons(True)
                End If
        Loop While (run)

        view.measLabel.Visible = False
        view.sampleCount.Visible = False

        If view.domain.SelectedIndex = 0 Then
            rsesci_status = rsesci_Abort(instrSession) : CheckError()
            System.Threading.Thread.Sleep(1000)
            rsesci_status = rsesci_GetScanStepSize(instrSession, 1, xFirstIncrement) : CheckError()
            rsesci_status = rsesci_GetScanStepSize(instrSession, 2, xSecondIncrement) : CheckError()
            partTempT1 = Array.CreateInstance(GetType(Double), scan1points)
            Array.Copy(scan1tempT1, partTempT1, scan1points)
            partTempT2 = Array.CreateInstance(GetType(Double), scan1points)
            Array.Copy(scan1tempT2, partTempT2, scan1points)
            view.AxCWGraph1.Plots.Item("Plot1").ChartY(partTempT1, xFirstIncrement)
            view.AxCWGraph1.Plots.Item("Plot2").ChartY(partTempT2, xFirstIncrement)

            partTempT1 = Array.CreateInstance(GetType(Double), scan2points)
            Array.Copy(scan2tempT1, partTempT1, scan2points)
            partTempT2 = Array.CreateInstance(GetType(Double), scan2points)
            Array.Copy(scan2tempT2, partTempT2, scan2points)
            view.AxCWGraph1.Plots.Item("Plot1").ChartY(partTempT1, xSecondIncrement)
            view.AxCWGraph1.Plots.Item("Plot2").ChartY(partTempT2, xSecondIncrement)
        Else
            partTempT1 = Array.CreateInstance(GetType(Double), scan1points)
            Array.Copy(scan1tempT1, partTempT1, scan1points)
            partTempT2 = Array.CreateInstance(GetType(Double), scan1points)
            Array.Copy(scan1tempT2, partTempT2, scan1points)
            view.AxCWGraph1.Plots.Item("Plot1").ChartY(partTempT1, (view.xStop - view.xStart) / points)
            view.AxCWGraph1.Plots.Item("Plot2").ChartY(partTempT2, (view.xStop - view.xStart) / points)
        End If

ErrorHandle:
        If (Err.Number <> 0) Then
            view.ErrorMessage(Err.Number, Err.Description)
        End If
        view.EnableButtons(True)
        rsesci_status = rsesci_close(instrSession) : CheckError()

    End Sub

    Private Sub CheckError()

        Dim instr_error As Integer
        Dim error_message As New String(" ", 1024)

        If (rsesci_status < 0) Then

            ' Query the error message from the instrument driver. This
            ' function gets the error message for VISA and driver failures
            rsesci_error_message(instrSession, rsesci_status, error_message)

            If (error_message.Length = 0) Then
                ' Query the error message from the instrument. This
                ' function gets the error message directly from instrument, like
                ' execution error, out of range error etc.
                rsesci_error_query(instrSession, rsesci_status, error_message)
            End If
            Err.Description = error_message
            Err.Raise(rsesci_status)
        End If

    End Sub

 End Class
